#include <storage.h>
#include <string.h>
#include <node.h>
#include <y.tab.h>
#include <node_smv.h>
#include <hash.h>
#include <assoc.h>
#include <util_err.h>
#include "symbols.h"
#include "mystring.h"
#include "eval.h"
#include "fts.h"
/*
#include "abstract.h"
*/

/* Yi Lv */
extern int npa;
extern int atype;
extern node_ptr abs_name;
extern node_ptr abs_module_name;
extern fts fts_list;
node_ptr RS = NIL;
char rs[BUFLEN] = "RS";

int ph_count = 1;
extern node_ptr ph_list;
node_ptr absvars = NIL;
node_ptr absfps = NIL;
extern hash_ptr abs_pred_hash;
extern hash_ptr inst_pred_hash;
extern hash_ptr inst_aux_pred_hash;
extern hash_ptr inv_hash;
extern hash_ptr aux_inv_hash;
extern int yyflag;

/*zhouyan*/
node_ptr node_name_list = NIL;
node_ptr abs_var_list = NIL;
node_ptr local_var_list = NIL;
node_ptr local_inst_var_list = NIL;
node_ptr global_inst_var_list = NIL;
extern hash_ptr ph_name_hash;

/* 
 * Check the var of module main and identify the process module which will be 
 * abstracted, return the name of the module.
 * For example, Node[npa] : process mymodule; return the node of name mymodule. 
 */
node_ptr check_abs_module(node_ptr parse_tree)
{
  node_ptr module, tempmodule, name, decs, dec, tempdec;
  node_ptr vlist, vitem, tempvitem, term, type, num;

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			decs = cdr(module);
			
			LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
		//	for(dec = car(decs); dec; decs = cdr(decs)) {			
				if (dec->type == VAR) {
					vlist = car(dec);
					LOOP_OVER_VARS( vlist, vitem, tempvitem ) {
						if (vitem->type == COLON) {
							term = car(vitem);
							type = cdr(vitem);
							if (term->type == ARRAY) {
								num = cdr(term);
								if (num->type == NUMBER && num->left.inttype == npa
									&& type->type == PROCESS) {
									return(caar(type));
								}
							}
						}
					}
				}
			}
		}
	}
	return (node_ptr)(-1);
}


// For example, Node[id] : process mymodule; return the node of Node[id]. 
node_ptr name_of_id(node_ptr parse_tree, int id)
{
  node_ptr module, tempmodule, name, decs, dec, tempdec;
  node_ptr vlist, vitem, tempvitem, term, type, num;

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			decs = cdr(module);
			
			LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
		//	for(dec = car(decs); dec; decs = cdr(decs)) {			
				if (dec->type == VAR) {
					vlist = car(dec);
					LOOP_OVER_VARS( vlist, vitem, tempvitem ) {
						if (vitem->type == COLON) {
							term = car(vitem);
							type = cdr(vitem);
							if (term->type == ARRAY) {
								num = cdr(term);
								if (num->type == NUMBER && num->left.inttype == id
									&& type->type == PROCESS) {
									//print_node(stdout, term);
									return(term);
								}
							}
						}
					}
				}
			}
		}
	}
	return (node_ptr)(-1);
}


/* 
 * For example, Node[npa] : process mymodule; return the node of Node[npa]. 
 */
node_ptr name_of_module_id(node_ptr parse_tree, int id)
{
  node_ptr module, tempmodule, name, decs, dec, tempdec;
  node_ptr vlist, vitem, tempvitem, term, type, num;

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			decs = cdr(module);
			
			LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
		//	for(dec = car(decs); dec; decs = cdr(decs)) {			
				if (dec->type == VAR) {
					vlist = car(dec);
					LOOP_OVER_VARS( vlist, vitem, tempvitem ) {
						if (vitem->type == COLON) {
							term = car(vitem);
							type = cdr(vitem);
							if (term->type == ARRAY) {
								num = cdr(term);
								if (num->type == NUMBER && num->left.inttype == id
									&& type->type == PROCESS) {
									return(term);
								}
							}
						}
					}
				}
			}
		}
	}
	return (node_ptr)(-1);
}

// Find the type of abstract module and change the name of type.
// For example, Node[npa]:process mymodule -> Node[npa]:process abs_mymodule.

int modify_abs_module(node_ptr parse_tree)
{
  node_ptr module, tempmodule, name, new_name, decs, dec, curdec, tempdec;
  node_ptr vlist, vitem, tempvitem, term, type, num, typename, typelist;
	char abs_txt[BUFLEN]="abs_";

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			node_ptr modtype = car(module);
			
			decs = cdr(module);
			LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
				if (dec->type == VAR) {
					vlist = car(dec);
					LOOP_OVER_VARS( vlist, vitem, tempvitem ) {
						if (vitem->type == COLON) {
							term = car(vitem);
							type = cdr(vitem);
							if (term->type == ARRAY) {
								num = cdr(term);
								if (num->type == NUMBER && num->left.inttype == npa
									&& type->type == PROCESS) { 
									typename = caar(type);
									typelist = cdar(type);
									if (typename->type != ATOM) {
										fprintf(stdout, "typename is not ATOM\n");
										return(-1);
									}
									new_name = string_to_atom(strcat(abs_txt, typename->left.strtype->text)); 	
									type->left.nodetype->left.nodetype = new_name;
									typelist->right.nodetype = append(typelist->right.nodetype, ph_list);
									return(0);
								}
							}
						}
					}
				}
			}
		}
	}
	return(-1);
}

int in_name_list(node_ptr name, node_ptr list) 
{
	
	node_ptr mylist = list;
	if(mylist == NIL) return(0);

	while(mylist != NIL) {
		if (name->type == ATOM && car(mylist)->type == ATOM) {
			if(string_eq(atom_to_string(name), atom_to_string(car(mylist)))) {
				return (1);
			}
		}
		mylist = cdr(mylist);
	}
	return (0);
}

/* generate the node of place holder. */
node_ptr gene_ph(int *count)
{
	char buf[BUFLEN]="p_";
	char num[BUFLEN];

	sprintf(num, "%d", (*count)++);
	return (string_to_atom(strcat(buf,num)));
}

// Recursively check whether the predicate exist abstract subformula. 1 implies Yes, 0 implies No.
int check_abs_pred(node_ptr pred, node_ptr absvars, int polar)
{
	if (pred == NIL) return (-1);
	switch (pred->type) {
	case ATOM:
		if (in_name_list(pred, absvars)) {
			return (1);
		} else {
			return (0);
		}
	case EQUAL:
	case NOTEQUAL:
		if (in_name_list(car(pred), absvars) || in_name_list(cdr(pred), absvars)) {
			return (1);
		} else {
			return (0);
		}
	case AND:
	case OR:
	case IFF:
		return (check_abs_pred(car(pred), absvars, polar) || check_abs_pred(cdr(pred), absvars, polar));
	case NOT:
		return (check_abs_pred(car(pred),absvars, -(polar)));
	case IMPLIES:
		return (check_abs_pred(car(pred), absvars, -(polar)) || check_abs_pred(cdr(pred), absvars, polar));
	default:
		return (0);
	}
}

/*
 * Recursively check the predicate pred. If the atom formula is abstract related formula
 * decided by absvars, and it occurs postive in predicate(polar = 1), then substitute TRUE for this atom formula. 
 * Otherwise(polar = -1), substitute FALSE for it.
 */
int modify_abs_pred(node_ptr pred, node_ptr absvars, int polar)
{
	int l, r;

	if (pred == NIL) return (-1);
	switch (pred->type) {
	case ATOM:
		if (in_name_list(pred, absvars)) {
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if (polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case EQUAL:
	case NOTEQUAL:
		if (in_name_list(car(pred), absvars) || in_name_list(cdr(pred), absvars)) {
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if (polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case AND:
	case OR:
	case IFF:
		//return (modify_abs_pred(car(pred), absvars, polar) || modify_abs_pred(cdr(pred), absvars, polar));
		l = modify_abs_pred(car(pred), absvars, polar);
		r = modify_abs_pred(cdr(pred), absvars, polar);
		return (l || r);
	case NOT:
		return (modify_abs_pred(car(pred),absvars, -(polar)));
	case IMPLIES:
		return (modify_abs_pred(car(pred), absvars, -(polar)) || modify_abs_pred(cdr(pred), absvars, polar));
	default:
		return (0);
	}
}


/*
 * node(a,b) ==> abs_node(a,b, p1, p2)
 */
int modify_abs_type(node_ptr abs_module)
{
	node_ptr type, typename, new_name;
	char abs_txt[BUFLEN]="abs_";

	type = car(abs_module);
	if (type->type != MODTYPE) {
		fprintf(stderr, "modetype error\n");
		return (-1);
	}
	typename = car(type);

	new_name = string_to_atom(strcat(abs_txt, typename->left.strtype->text)); 	
	type->left.nodetype = new_name;
	type->right.nodetype = append(type->right.nodetype, ph_list);
	return (0);
}

/* Build the abstracted module according to the absvars. 
 * Let s be the variable of abstract variables, t is the global variable.
 * next(s) := expr; ==> blank;
 * next(t) := s & t ==> next(t) := TRUE & t;
 * If flag = 1, only predicate related to formal parameter of absvars will be modified. 
 * Else the place holder will be counted.
 */
int build_abs_decs(node_ptr abs_module, node_ptr absvars, int flag)
{
	node_ptr dec, tempdec, alist, aitem, term, templist, ph;
	node_ptr alhs, expr;
	int polar;
	node_ptr decs = cdr(abs_module); 
	LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
	//for(dec=car(decs); dec; decs=cdr(decs)) {
		switch(dec->type) {
		case ASSIGN:
			alist = car(dec);
			//LOOP_OVER_ITEMS( alist, aitem, templist ) {
			for(templist = car(dec), aitem = car(alist); aitem; ) {
				if (aitem->type != EQDEF){
					fprintf(stderr, "aitem's type is not EQDEF\n");
					return (-1);
				}
				alhs = car(aitem); 
				expr = cdr(aitem);
				switch(alhs->type) {
				case SMALLINIT:
				case NEXT:
					term = car(alhs);
					if (term->type == ATOM) {
						if (in_name_list(term, absvars)) {
							if (car(dec) == alist) {
								dec->left.nodetype = cdr(templist);
								alist = cdr(alist);
								templist =  alist;
								goto NEXTASS;
							} else {
								alist = cdr(alist);
								templist->right.nodetype = alist;
								goto NEXTASS;
							}
						}
					}
					if (expr->type != CASE) {
						break;
						//goto NEXTASS;
						//fprintf(stderr, "expr's type is not CASE\n");
						//return (-1);
					}
					node_ptr rule, pred, abs_pred, assign, temprule;
					LOOP_OVER_RULES( expr, rule, temprule ) {
					//	for(rule = car(expr); rule; expr = cdr(expr)) {
						if (rule->type != COLON) {
							fprintf(stderr, "rule's type is not COLON\n");
							return (-1);
						}
						
						pred = car(rule);
						polar = 1;	
						if(!flag){
							abs_pred = new_node(AND, NIL, NIL);
							if (copy_node(pred, abs_pred) == -1) {
								fprintf(stderr, "copy pred node to abs_pred node error\n");
								return (-1);
							}
							if ((check_inst_pred(fts_list->components, abs_module_name, pred) == 0) && 
									(modify_abs_pred(pred, absvars, polar) == 1)) {
								if ((ph = find_pred_assoc(abs_pred_hash, abs_pred)) == NIL) {
									ph = gene_ph(&ph_count);
									ph_list = cons(ph, ph_list);
									insert_assoc(abs_pred_hash,ph,abs_pred);
								}
								pred = new_node(AND, ph, pred);							 
								rule->left.nodetype = pred;
							//} else if (modify_abs_pred(pred, absvars, polar) == 0) {
							} else {
								free_node(abs_pred);							
							} 
						}	else {
							modify_abs_pred(pred, absvars, polar); 
						}
					}						
					break;
				default:
					break;
				}
				templist = alist;
				alist = cdr(alist);
NEXTASS:
				if (alist == NIL){
					aitem = NIL;
				} else {
					aitem = car(alist);
				}
			}
		default:
			break;
		}
	}
	return (0);
}

int find_abs_decs(node_ptr abs_module)
{
	node_ptr dec, tempdec, alist, aitem, term, templist, ph;
	node_ptr alhs, expr;
	int polar;

	node_ptr decs = cdr(abs_module); 
	LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
	//for(dec=car(decs); dec; decs=cdr(decs)) {
		switch(dec->type) {
		case ASSIGN:
			alist = car(dec);
			LOOP_OVER_ITEMS( alist, aitem, templist ) {
			//for(templist = car(dec), aitem = car(alist); aitem; ) {
				if (aitem->type != EQDEF){
					fprintf(stderr, "aitem's type is not EQDEF\n");
					return (-1);
				}
				alhs = car(aitem); 
				expr = cdr(aitem);
				switch(alhs->type) {
				case SMALLINIT:
				case NEXT:
					if (expr->type != CASE) {
						break;
					}
					node_ptr rule, pred, assign, temprule;
					LOOP_OVER_RULES( expr, rule, temprule ) {
					//	for(rule = car(expr); rule; expr = cdr(expr)) {
						if (rule->type != COLON) {
							fprintf(stderr, "rule's type is not COLON\n");
							return (-1);
						}
						
						pred = car(rule);
						polar = 1;	
						if (check_abs_pred(pred, absvars, polar) == 1) {
							if ((ph = find_pred_assoc(abs_pred_hash, pred)) == NIL) {
								ph = gene_ph(&ph_count);
								ph_list = cons(ph, ph_list);
								insert_assoc(abs_pred_hash,ph,pred);
							}
						}
					}						
					break;
				default:
					break;
				}
			}
		default:
			break;
		}
	}
	return (0);
}
int IS_absvar(node_ptr fp)
{
	char mybuf[BUFLEN]="";
	char tmpbuf[BUFLEN]="";
	sprintf(mybuf, "_N%d", npa);
	last_n_string(atom_to_string(fp),tmpbuf, npa);
	if(string_eq(tmpbuf, mybuf))
		return 1;
	else
		return 0;
}

int build_absvars(node_ptr module)
{
  node_ptr name, decs, dec, curdec, tempdec;
  node_ptr fplist, fp, tempfp;
  node_ptr vlist, vitem, tempvitem, term, type, num;

// If there are formal parameter fp in module has the type of var_Ni, and i is the parameter of system,
// then this fp will be counted in absfps. 
	fplist = cdar(module);
	LOOP_OVER_FPARAMS( fplist, fp, tempfp ) {
		if (fp->type == ATOM) {
			if (IS_absvar(fp)) {
				absfps = cons(fp, absfps);
			}
		}
	}

	decs = cdr(module);

	if (absfps != NIL) {
		absvars = new_node(LIST, NIL, NIL);
		if(copy_node(absfps, absvars))
			fprintf(stderr, "copy absvars error\n");
	}

	LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
		if (dec->type == VAR) {
			vlist = car(dec);
			LOOP_OVER_VARS( vlist, vitem, tempvitem ) {
				if (vitem->type == COLON) {
					term = car(vitem);
					if (term->type == ATOM) {
						absvars = cons(term, absvars);
					} else {
						return (-1);
					}
				}
			}
		}
	}
	return (0);
}


/* Find the definition of the module whose name is matched with the abstract name.
 * For example, return the node of defintion of MODULE mymodule. */
node_ptr find_abs_definition(node_ptr parse_tree, node_ptr abs_name)
{
  node_ptr temp;
  node_ptr module;

  LOOP_OVER_MODULES( parse_tree, module, temp ) {
    node_ptr name = name_of_module(module);

		if (string_eq(atom_to_string(name), atom_to_string(abs_name)))
				return (node_ptr)module;
  }
	return (node_ptr)(-1);
}

int check_abs_assign(node_ptr module)
{
	if (build_absvars(module))
		fprintf(stderr, "build absvars error\n");

	if (!abs_pred_hash) {
		abs_pred_hash = new_assoc();
	}

	if (find_abs_decs(module) == -1){
		fprintf(stderr, "check abstract declarations error\n");
		return (-1);
	}

	return (0);
}

node_ptr build_abs_module(node_ptr module)
{
	node_ptr abs_module = new_node(MODULE, NIL, NIL);
	if (copy_node(module, abs_module))
		fprintf(stderr, "copy module error\n");

	if (build_absvars(module))
		fprintf(stderr, "build absvars error\n");

	if (!abs_pred_hash) {
		abs_pred_hash = new_assoc();
	}

	if (build_abs_decs(abs_module, absvars, 0) == -1){
		fprintf(stderr, "build abstract declarations error\n");
		return (node_ptr)(-1);
	}

	if (modify_abs_type(abs_module) == -1){
		fprintf(stderr, "modify abstract module type error\n");
		return (node_ptr)(-1);
	}
	return (abs_module);
}

/*
int check_abs_program (node_ptr parse_tree)
{
	node_ptr module_name, mymodule;

	module_name = check_abs_module(parse_tree);

	abs_name = name_of_abs_module(parse_tree);

	mymodule = find_abs_definition(parse_tree, module_name);

	check_abs_assign(mymodule);

	return (0);
}
*/

int check_abs_program (node_ptr parse_tree)
{
	node_ptr module_name, mymodule;

	module_name = check_abs_module(parse_tree);

	mymodule = find_abs_definition(parse_tree, module_name);

	check_abs_assign(mymodule);

	return (0);
}

int build_abs_program (node_ptr parse_tree)
{
	node_ptr module_name, mymodule, abs_module;

	module_name = check_abs_module(parse_tree);
	mymodule = find_abs_definition(parse_tree, module_name);

	abs_module = build_abs_module(mymodule);

	if (build_abs_decs(mymodule, absfps, 1) == -1){
		fprintf(stderr, "build abstract formal parameter declarations error\n");
		return (-1);
	}

	abs_module = cons(abs_module, NIL);
	modify_abs_module(parse_tree);
	parse_tree = append(parse_tree, abs_module);

	return (0);
}

// Find instantiated predicate from component.
// For example, abstract pred is "state = Idle", context is "Node[2]", 
// we will find the pred "state = Idle" and it's context "Node[2]".
node_ptr find_inst_pred(component_ptr c, node_ptr context, node_ptr apred)
{
	node_ptr res = NIL;
	node_ptr dec, tempdec, alist, aitem, term, templist;
	node_ptr alhs, expr, pred;

	if (c == 0) return NIL;

	if ((res = find_inst_pred(c->c1, context, apred)) != NIL)
		return (res);

	if ((res = find_inst_pred(c->c2, context, apred)) != NIL)
		return (res);

	if ((c->context != NIL) && context_match(c->context, context)) {
		alist = cdar(c->assign);
		LOOP_OVER_ITEMS( alist, aitem, templist ) {
		//for(templist = car(dec), aitem = car(alist); aitem; ) {
			if (aitem->type != EQDEF){
				fprintf(stderr, "aitem's type is not EQDEF\n");
				return (node_ptr)(-1);
			}
			alhs = car(aitem);
			expr = cdr(aitem);
			switch(alhs->type) {
			case SMALLINIT:
			case NEXT:
				if (expr->type != CASE) {
					fprintf(stderr, "expr's type is not CASE\n");
					return (node_ptr)(-1);
				}
				node_ptr rule, pred, abs_pred, assign, temprule;
				LOOP_OVER_RULES( expr, rule, temprule ) {
				//	for(rule = car(expr); rule; expr = cdr(expr)) {
					if (rule->type != COLON) {
						fprintf(stderr, "rule's type is not COLON\n");
						return (node_ptr)(-1);
					}
							
					pred = car(rule);
					if (pred_match(pred, apred)) {
						return (pred);
					}
				}
				break;
			default:
				break;
			}
		}
	}
	return NIL;
}


node_ptr find_inst_context(component_ptr c, node_ptr context)
{
	node_ptr res = NIL;

	if (c == 0) return NIL;

	if ((c->context != NIL) && context_match(c->context, context)) {
		return (c->context);
	}

	if ((res = find_inst_context(c->c1, context)) != NIL)
		return (res);

	if ((res = find_inst_context(c->c2, context)) != NIL)
		return (res);

	return NIL;
}

// For example, name is "Node[2]", _p_1 is "state = Idle", then
// Node[2].state = Idle will be generated and be inserted in inst_aux_pred_hash.
int gene_inst_aux_pred(component_ptr c, node_ptr name, node_ptr ph_list)
{
	node_ptr ph, apred, ipred, pred_F, context;

	if (!inst_aux_pred_hash) {
		inst_aux_pred_hash = new_assoc();
	}
	

	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
			ph = (ph_list == NIL) ? NIL : car(ph_list)) {
		apred = find_assoc(abs_pred_hash, ph);
		if ((ipred = find_inst_pred(c, name, apred)) == NIL) {
			fprintf(stdout, "find_inst_pred error\n");
			return (-1) ;
		}
		if ((context = find_inst_context(c, name)) == NIL) {
			fprintf(stdout, "find_inst_context error\n");
			return (-1) ;
		}
		//modify_abs_pred(ipred, absfps, 1);
		pred_F = eval_F(ipred, context);
		insert_assoc(inst_aux_pred_hash, ph, pred_F);

	}

	return (0);
}


//Check whether the value of instantiated predicate is FALSE
 
int check_inst_pred(component_ptr c, node_ptr name, node_ptr pred)
{
	node_ptr ipred, context;
	bdd_ptr bpred;
	
	if ((ipred = find_inst_pred(c, name, pred)) == NIL) {
		fprintf(stdout, "find_inst_pred error\n");
		return (-1) ;
	}

	if ((context = find_inst_context(c, name)) == NIL) {
		fprintf(stdout, "find_inst_context error\n");
		return (-1) ;
	}

	bpred = save_bdd(eval(ipred, context));
	if (bpred == ZERO)
		return (1);
	else
		return (0);
}

int gene_inst_pred(component_ptr c, node_ptr name, node_ptr ph_list)
{
	node_ptr ph, apred, ipred, pred_F, context;

	if (!inst_pred_hash) {
		inst_pred_hash = new_assoc();
	}
	
	//name = name_of_abs_module(parse_tree);

	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
			ph = (ph_list == NIL) ? NIL : car(ph_list)) {
		apred = find_assoc(abs_pred_hash, ph);
		if ((ipred = find_inst_pred(c, name, apred)) == NIL) {
			fprintf(stdout, "find_inst_pred error\n");
			return (-1) ;
		}
		if ((context = find_inst_context(c, name)) == NIL) {
			fprintf(stdout, "find_inst_context error\n");
			return (-1) ;
		}
		pred_F = eval_F(ipred, context);
		insert_assoc(inst_pred_hash, ph, pred_F);

		//print_node(stdout, find_assoc(inst_pred_hash, ph));
	}

	return (0);
}

int compute_reach()
{
	node_ptr var = string_to_atom("RS");
	node_ptr val_name = string_to_atom("reachable");

	node_ptr val = new_node(FUNC, val_name, NIL);
	tlv_assign_command(var, val);
	RS = var;

	return (0);
}

node_ptr inst_var_list(component_ptr c, node_ptr absvars, node_ptr lname, int id)
//node_ptr inst_var_list(component_ptr c, node_ptr absvars, node_ptr lname, int id, node_ptr ivar_list)
//node_ptr inst_var_list(component_ptr c, node_ptr absvars, node_ptr name)
{
	node_ptr context;
	node_ptr avar_list = absvars;
	node_ptr avar = NIL;
	char* str;
	char buf1[BUFLEN];
	char buf2[BUFLEN];
	int len = 0;
	node_ptr ivar_list = NIL;

	if ((context = find_inst_context(c, lname)) == NIL) {
		fprintf(stdout, "find_inst_context error\n");
		return (node_ptr)(-1) ;
	}

	memset(buf2, 0, BUFLEN);
	sprintf(buf2, "%d", id);
	for (avar = car(avar_list); avar; avar_list = cdr(avar_list), 
			avar = (avar_list == NIL) ? NIL : car(avar_list)) {
		if (IS_absvar(avar)) {
			str = atom_to_string(avar);
			len = strlen(str);	
			memset(buf1, 0, BUFLEN);
			strncpy(buf1, str, len-1); 
			avar = string_to_atom(strcat(buf1, buf2));
		}
		//ivar_list = cons(eval_F(avar, context), ivar_list);
		ivar_list = cons(eval_struct(avar, context), ivar_list);
	}
	//print_node(stdout,ivar_list);
	//printf("\n");
	return(ivar_list);
	
//	return (eval_F(absvars, context));
}

int gene_ph_inv(node_ptr parse_tree, component_ptr c, node_ptr ph)
{
	int i, j;
	node_ptr myname, pred, name_list;
	bdd_ptr sup, reach, res, result;

	result = save_bdd(ONE);
	for(i = 1; i < npa; i++) {
		name_list = NIL;
		sup = save_bdd(ONE);
		for(j = 1; j <= npa; j++) {
			if (j != i) {
				myname = NIL;
				myname = name_of_id(parse_tree, j);
				//name_list = cons(inst_var_list(c, absvars, name, j), name_list);
				//inst_var_list(c, absvars, myname, j, name_list);
				name_list = inst_var_list(c, absvars, myname, j);
				sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
				//name_list = cons(inst_var_list(c, absvars, name), name_list);
			}
		}
		//sup = (bdd_ptr)calc_list_support(name_list);
		pred = find_assoc(inst_pred_hash, ph);
		reach = and_bdd(eval(RS, NIL), eval(pred, NIL));
		res = forsome(sup, reach);
		result = and_bdd(res, result);
	}
	//print_node(stdout,(node_ptr)result);
	//printf("\n");
	insert_assoc(inv_hash, ph, (node_ptr)result);
 
	return (0);
}

int gene_ph_aux_inv(node_ptr parse_tree, component_ptr c, node_ptr ph)
{
	int i = 1, j;
	node_ptr myname, pred, aux_pred, name_list;
	bdd_ptr sup = ONE, reach, res, result;

	//result = save_bdd(ONE);

	name_list = NIL;
	sup = save_bdd(ONE);
	for(j = 1; j <= npa; j++) {
		if (j != i) {
			myname = name_of_id(parse_tree, j);
			//name_list = cons(inst_var_list(c, absvars, name, j), name_list);
			//inst_var_list(c, absvars, myname, j, name_list);
			name_list = inst_var_list(c, absvars, myname, j);
			sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
			//name_list = cons(inst_var_list(c, absvars, name), name_list);
		}
	}
	//sup = (bdd_ptr) calc_list_support(name_list);
	aux_pred = find_assoc(inst_aux_pred_hash, ph);
	reach = and_bdd(eval(RS, NIL), eval(aux_pred, NIL));
	res = forsome(sup, reach);
	modify_abs_pred(aux_pred, absvars, 1);
	result = or_bdd(not_bdd(eval(aux_pred, NIL)), res);

	insert_assoc(aux_inv_hash, ph, (node_ptr)result);
 
	return (0);
}

int gene_inv(node_ptr parse_tree, component_ptr c, node_ptr ph_list)
{
	node_ptr ph;
	
	if (!inv_hash) {
		inv_hash = new_assoc();
	}

	if (!aux_inv_hash) {
		aux_inv_hash = new_assoc();
	}

	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
		ph = (ph_list == NIL) ? NIL : car(ph_list))  {
		gene_ph_inv(parse_tree, c, ph);
		gene_ph_aux_inv(parse_tree, c, ph);
	}

	return (0);
}

int print_inv(FILE *stream, node_ptr ph_list)
{
	bdd_ptr inv, aux_inv;
	node_ptr ph;
	char auxs[BUFLEN]= "aux_"; 
	char buf[BUFLEN];

	if(ph_list == NIL)
		return 0;	
	
	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
		ph = (ph_list == NIL) ? NIL : car(ph_list))  {
		inv = (bdd_ptr)find_assoc(inv_hash, ph);
		dump_bdd_formula(stream, inv, 1, atom_to_string(ph));
		strcpy(buf, auxs);
		strcat(buf, atom_to_string(ph));
		aux_inv = (bdd_ptr)find_assoc(aux_inv_hash, ph);
		dump_bdd_formula(stream, aux_inv, 1, buf);	
		fflush(stream);
	}

	return (0);
}

//zhouyan
int print_spec(FILE *stream, node_ptr ph_list){
	node_ptr ph;
	char auxs[BUFLEN]= "aux_";
	char buf[BUFLEN];
	if(ph_list == NIL)
		return 0;	
	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
		ph = (ph_list == NIL) ? NIL : car(ph_list))  {
		fprintf(stream, "\nSPEC\n");
		fprintf(stream, "AG(");
		strcpy(buf, auxs);
		strcat(buf, atom_to_string(ph));
		fprintf(stream, "%s", buf);
		fprintf(stream, ")\n");
	}
	return 0;
	
}
int print_program(FILE *stream, node_ptr parse_tree, node_ptr ph_list, FILE *invf)
//int print_program(FILE *stream, node_ptr parse_tree, node_ptr old_parse_tree, node_ptr ph_list)
{
  node_ptr module, tempmodule, name;
	char ch;

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			fprintf(stream, "MODULE ");
			print_node(stream, car(module));			
			fprintf(stream, "\nDEFINE\n");
			while((ch = fgetc(invf)) != EOF)
				fputc(ch, stream);
			//print_inv(stream, ph_list);
			print_spec(stream, ph_list);
			print_node(stream, cdr(module));
		} else {
			print_node(stream, module);
		}
	}
	return (0);
}

int print_pf(FILE *stream, node_ptr parse_tree, node_ptr ph_list)
{
  node_ptr module, tempmodule, name, decs, dec, tempdec;
  node_ptr ctlf, ph;
	char auxs[BUFLEN]= "aux_"; 
	char buf[BUFLEN];

  LOOP_OVER_MODULES( parse_tree, module, tempmodule ) {
    name = name_of_module(module);
    if (string_eq(atom_to_string(name), "main")) {
			decs = cdr(module);
			
			LOOP_OVER_DECLARATIONS( decs, dec, tempdec ) {
				if (dec->type == SPEC) {
					ctlf = car(dec);
					if (ctlf->type == AG) {
						fprintf(stream, "Print \"\\nInvariance(");
						print_node(stream, car(ctlf));
						fprintf(stream, ");\\n\";\n");

						fprintf(stream, "Invariance(");
						print_node(stream, car(ctlf));
						fprintf(stream, ");\n");
					}
				}
			}
		}
	}

	if(ph_list == NIL){
		return 0;
	}

	for (ph = car(ph_list); ph; ph_list = cdr(ph_list), 
		ph = (ph_list == NIL) ? NIL : car(ph_list))  {
		strcpy(buf, auxs);
		strcat(buf, atom_to_string(ph));

		fprintf(stream, "Print \"\\nInvariance(");
		fprintf(stream, "%s", buf); 
		fprintf(stream, ");\\n\";\n");

		fprintf(stream, "Invariance(");
		fprintf(stream, "%s", buf); 
		fprintf(stream, ");\n");
	}

	fprintf(stream, "quit;");
	return (0);
}

/*zhouyan*/
node_ptr find_module_by_name (node_ptr parse_tree, char* name) {
	node_ptr program, module, tempmodule, modulename;
	if(parse_tree == NIL) return NIL;
	program = parse_tree;
	LOOP_OVER_MODULES(program, module, tempmodule){
		modulename = name_of_module(module);
		//printf("%s\n",atom_to_string(modulename));
		if(string_eq(atom_to_string(modulename), name))
			return module;
	}
	return NIL;
}

node_ptr find_tran_by_name (node_ptr parse_tree, char* name) {
	node_ptr main_module;
	node_ptr decs, dec, tempdec, vars, var, tempvar;
	main_module = find_module_by_name(parse_tree, "main");
	decs = cdr(main_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				if(cdr(var)->type == PROCESS) {
					if(car(var)->type == ATOM) {
						if(string_eq(atom_to_string(car(var)),name))
							return var;
					}
				}
			}
		}
	}
	return NIL;
}

int get_proc_num (node_ptr parse_tree) {
	int num = 0;
	node_ptr decs, dec, tempdec, vars, var, tempvar, main_module, node_module;  
	main_module = find_module_by_name (parse_tree, "main");
	//printf("%s\n",atom_to_string(name_of_module(main_module)));
	if(main_module == NIL) return 0;	
	decs = cdr(main_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		//printf("%d\n",dec->type);
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				//printf("%d\n",cdr(var)->type);
				if(cdr(var)->type == MODTYPE){
					//printf("%s\n",atom_to_string(caar(cdr(var))));
					//node_module = find_module_by_name(parse_tree, atom_to_string(caar(cdr(var))));
					node_module = find_module_by_name(parse_tree, atom_to_string(car(cdr(var))));
					if(check_module_has_init(node_module)==1){
						node_name_list = cons(car(var),node_name_list);
						num++;
					}
				}
			}
		}
	}
	//print_node(stdout,node_name_list);
	if (node_name_list == NIL) {
		fprintf(stdout, "node_name_list is empty: procees key word error\n"); 
		return (-1);
	}
	return num;
}

int check_module_has_init(node_ptr module) {
		node_ptr decs, dec, tempdec, items, curritem, temp_node_ptr;
		decs = cdr(module);
		//pn(name_of_module(module));
		//printf("\n");
		LOOP_OVER_DECLARATIONS(decs, dec, tempdec){
			if (dec->type == ASSIGN) {
				items = car(dec);
				if(items == NIL) 
					return 0;
				LOOP_OVER_ITEMS(items, curritem, temp_node_ptr) {
					//printf("%d\n",car(curritem)->type);
					if(car(curritem)->type == SMALLINIT)
						return 1;
				}
			}
		}
		return 0;
}

node_ptr gene_abs_name(node_ptr src_name) {
	node_ptr new_name;
	char abs_name[BUFLEN] = "ABS_";
	new_name = string_to_atom(strcat(abs_name,atom_to_string(src_name)));
	return new_name;
}

node_ptr gene_local_var_list(node_ptr parse_tree) {
	node_ptr program, module, tempmodule, modulename, decs, dec, tempdec, vars, var, tempvar;
	local_var_list = NIL;
	if(parse_tree == NIL) return NIL;
	program = parse_tree;
	LOOP_OVER_MODULES(program, module, tempmodule){
		modulename = name_of_module(module);
		if(!string_eq(atom_to_string(modulename),"main")&&(check_module_has_init(module)==1)) {
			decs = cdr(module);
			LOOP_OVER_DECLARATIONS(decs, dec, tempdec){
				if (dec->type == VAR) {
					vars = car(dec);
					LOOP_OVER_VARS(vars, var, tempvar) {
						local_var_list = cons(var,local_var_list);
					}
				}
			}
		}
	}
	return local_var_list;
}

node_ptr gene_abs_var_list(node_ptr parse_tree, node_ptr module, int proc_num) {
	node_ptr decs, dec, tempdec, vars, var, tempvar, tempmodule = NIL;
	decs = cdr(module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				if(cdr(var)->type != PROCESS) {
					if(check_abs_var(parse_tree, var, proc_num)==1) {
						abs_var_list = cons(var,abs_var_list);
						//printf("abs var: %s\n",atom_to_string(car(var)));
					}
					/* for german2004*/
					if(cdr(var)->type == MODTYPE) {
						//print_node(stdout,var);
						//printf("\n");
						//printf("%s\n",atom_to_string(cadr(var)));
						tempmodule = find_module_by_name(parse_tree, atom_to_string(cadr(var)));
						if(module == NIL) {
							rpterr("Error: var define error.\n");
							return NIL;
						}
						gene_abs_var_list(parse_tree, tempmodule,proc_num);
					}
				}
			}
		}
	}
	return abs_var_list;
}

//1.InvSet_N3 : type 
//2.InvSet : array 1..N of type
int check_abs_var(node_ptr parse_tree, node_ptr var, int proc_num) {
	char mybuf[BUFLEN] = "";
	char tmpbuf[BUFLEN] = "";
	node_ptr module, decs, curdec, tempdec, vars, curvar, tempvar = NIL;
	int flag = 0;
	sprintf(mybuf, "_N%d", proc_num);
	switch(cdr(var)->type) {
		case TWODOTS:
			last_n_string(atom_to_string(car(var)),tmpbuf,3);
			if(string_eq(tmpbuf,mybuf))
				return 1;
			else
				return 0;
		case ARRAY:
			if(cadr(var)->type == TWODOTS) {
				if(car(cadr(var))->type == ATOM && string_eq(atom_to_string(car(cadr(var))),"N"))
					return 1;
				else if(cdr(cadr(var))->type == ATOM && string_eq(atom_to_string(cdr(cadr(var))),"N"))
					return 1;
				else
					return 0;
			}
			return 0;
		case MODTYPE:/* for german2004*/
			flag = 0;
			module = find_module_by_name(parse_tree, atom_to_string(cadr(var)));
			if(module == NIL) {
				rpterr("Error: var define error.\n");
				return 0;
			}
			decs = cdr(module);
			LOOP_OVER_DECLARATIONS(decs, curdec, tempdec) {
				if (curdec->type == VAR) {
					vars = car(curdec);
					LOOP_OVER_VARS(vars, curvar, tempvar) {
						if(cdr(curvar)->type != PROCESS) {
							if(check_abs_var(parse_tree, curvar, proc_num) == 1) {
								flag = 1;
							}
						}
					}
				}
			}
			if(flag == 1)
				return 1;
			return 0;
		default:
			return 0;
	}
}

char * name_of_abs_node(node_ptr node_list, int i) {
	node_ptr items, item, tempitem;
	char abs_node[BUFLEN]="";
	char *absnode = NULL;
	
	if(node_list == NIL) {
		fprintf(stderr, "node_list is empty\n");
		return NULL;
	}
	items = node_list;
	LOOP_OVER_ITEMS(items,item,tempitem) {
		if((item->type == ARRAY) && (car(item)->type == ATOM) && cdr(item)->left.inttype == i) {
			sprint_node(abs_node, BUFLEN, item);
			strcat(abs_node, ".");
			absnode = abs_node;
			return(absnode);
		}
	}
	return NULL;
}

int is_node_in_list(node_ptr node, node_ptr node_list, int i) {
	node_ptr items, item, tempitem;
	if(node == NIL || node_list == NIL)
		return 0;
	items = node_list;
	//print_node(stdout,node);
	//printf("\n");
	LOOP_OVER_ITEMS(items,item,tempitem) {
		
		switch(item->type) {
			case ATOM:
				if(node->type == ATOM) {
					if(string_eq(atom_to_string(item),atom_to_string(node))==1) 
						return 1;
					else
						break;
				} else if(node->type == DOT) {
					if(string_eq(atom_to_string(item),atom_to_string(cdr(node)))==1) 
						return 1;
					else
						break;
				} else {
					break;
				}
			case ARRAY://node[1]				
				if(node->type == ARRAY) {
						
					if(car(node)->type == ATOM) {						
						if(string_eq(atom_to_string(car(item)),atom_to_string(car(node)))==1 && cdr(node)->left.inttype == i)
							return 1;
						else
							break;
					} else if(car(node)->type == DOT) {
						//print_node(stdout,item);
						//printf("\n");
						//printf("-%s\n",atom_to_string(cdar(node)));
						if(string_eq(atom_to_string(car(item)),atom_to_string(cdar(node)))==1 && cdr(node)->left.inttype == i)
							return 1;
						else
							break;
					} else 
						break;
				} else if(node->type == DOT) {
					if(string_eq(atom_to_string(car(item)),atom_to_string(cdr(node)))==1) 
						return 1;
					else
						break;
				} else {
					break;
				}
			case COLON:
				if(node->type == ARRAY) {
					if(car(node)->type == ATOM) {
						if(string_eq(atom_to_string(car(item)),atom_to_string(car(node)))==1 && cdr(node)->left.inttype == i)
							return 1;
						else
							break;
					} else if(car(node)->type == DOT) {
						if(string_eq(atom_to_string(car(item)),atom_to_string(cdar(node))) && cdr(node)->left.inttype == i)						
							//printf("%s:%s.%d\n",atom_to_string(car(item)),atom_to_string(cdar(node)),cdr(node)->left.inttype);
							return 1;
						else
							break;
					} else 
						break;
				} else if(node->type == ATOM) {
					if(string_eq(atom_to_string(car(item)),atom_to_string(node))==1) 
						return 1;
					else
						break;
				} else if(node->type == DOT) {
					if(string_eq(atom_to_string(item),atom_to_string(cdr(node)))==1) 
						return 1;
					else
						break;
				} else {
					break;
				}				
			default:
				break;
		}
	}
	return 0;
}

int is_global_abs_var(node_ptr var_name, int i) {
	node_ptr items, item, tempitem;
	char abs_arr[BUFLEN]="";
	char vbuf[BUFLEN] = "";
	char gbuf[BUFLEN] = "";
	char *lb = "[";
	char *rb = "]";
	
	if (var_name == NIL) return (0);
	/*
	if (var_name == NIL) {
		fprintf(stderr, "var_name is empty in is_global_abs_var\n");
		return(-1);
	}
	*/

	sprintf(abs_arr, "%s%d%s", lb, i, rb);
	sprint_node(vbuf, BUFLEN, var_name);

	//[i] does not exist in var_name
	if(strstr(vbuf, abs_arr) == NULL) {
		return (0);
	}

	items = global_inst_var_list;
	LOOP_OVER_ITEMS(items,item,tempitem) {
		memset(gbuf, 0, sizeof(gbuf));
		sprint_node(gbuf, BUFLEN, item);
		if (string_eq(vbuf, gbuf) == 1) {
			return (1);
		}
	}

	return (0);
}

int is_local_abs_var(node_ptr var_name, int i) {
	char buf[BUFLEN] = "";
	char * absname;
	int j;

	if (var_name == NIL) return (0);
	/*
	if (var_name == NIL) {
		fprintf(stderr, "var_name is empty in is_local_abs_var\n");
		return(-1);
	}
	*/

	if ((absname = name_of_abs_node(node_name_list, i)) == NULL) {
		fprintf(stderr, "name of abs node error\n");
		return(-1);
	}


	j = (int)strlen(absname);
	sprint_node(buf, j, var_name);
	if (string_eq(buf, absname) == 1) {
		return (1);
	}
	return (0);
}

/*
int is_abs_var(node_ptr var_name, int i) {	
	node_ptr items, item, tempitem;
	char abs_arr[BUFLEN]="";
	char vbuf[BUFLEN] = "";
	char gbuf[BUFLEN] = "";
	char *lb = "[";
	char *rb = "]";
	char * absname;

	if (var_name == NIL) return (0);

	//global variable exists with the form of "*[i]*" in its substring
	sprintf(abs_arr, "%s%d%s", lb, i, rb);
	sprint_node(vbuf, BUFLEN, var_name);

	//local variable with the begining form of "Node[i].*"
	if ((absname = name_of_abs_node(node_name_list, i)) == NULL) {
		fprintf(stderr, "name of abs node error\n");
		return(-1);
	}

	items = fts_list->variables;
	LOOP_OVER_ITEMS(items,item,tempitem) {
		memset(gbuf, 0, sizeof(gbuf));
		sprint_node(gbuf, BUFLEN, item);
		if (string_eq(vbuf, gbuf) == 1) {
			//local abs variable
			if (strncmp(vbuf, absname, strlen(absname)) == 0) {
				return (1);
			}
			//global abs variable
			if(strstr(vbuf, abs_arr) != NULL) {
				return (1);
			}
		}
	}
	return (0);
} 
*/

/*
int is_abs_var(node_ptr var_name, int i) {	
	if (is_global_abs_var(var_name, i) == 1 || is_local_abs_var(var_name, i) == 1) {
		return (1);
	}
	return (0);
}
*/


int is_abs_var(node_ptr var_name, int i) {	
	node_ptr tempptr, tempptr2 = NIL;
	int flag = 0,j;
	if(var_name == NIL) {return 0;}
	//printf("_______i=%d__________________________\n",i);
	//print_node(stdout,var_name);
	//printf("\n");		
	switch(var_name->type) {
		case DOT:	
			tempptr = var_name;
			if(car(var_name) != NIL){
				while (car(tempptr)!=NIL&&(tempptr->type == DOT||(tempptr->type == ARRAY&&car(tempptr)->type == DOT))) {	
					tempptr = car(tempptr);
					//print_node(stdout,tempptr);
					//printf("\n%d\n",tempptr->type);
					if(tempptr->type == ARRAY && caar(tempptr)==NIL)
						break;
				}
			} 
			//print_node(stdout,tempptr);
			//printf("\n");
			if(is_node_in_list(tempptr, node_name_list, i) == 1) {
				return 1;
			} 
			for(j=1;j<i;j++){
				if(is_node_in_list(tempptr, node_name_list, j) == 1) {
					return 0;
				} 
			}
			//for german 2004
			flag = 1;			
			if(is_node_in_list(cdr(var_name), abs_var_list, i)==0)
				flag = 0;
			if(car(var_name) != NIL){
				tempptr = car(var_name);
				//print_node(stdout,var_name);
				//printf("  123\n");
				while (tempptr->type == DOT||(tempptr->type == ARRAY&&car(tempptr)->type == DOT)) {
					if(tempptr->type == DOT) {						
						if(is_node_in_list(cdr(tempptr), abs_var_list, i)==0)
							flag = 0;
						tempptr = car(tempptr);
					} else {
						tempptr2 = new_node(ARRAY,cdar(tempptr),cdr(tempptr));
						if(is_node_in_list(tempptr2,abs_var_list, i)==0)
							flag = 0;
						tempptr = caar(tempptr);
					}
					if(tempptr == NIL) 
						break;
				}
			} 
			return flag;
		case ARRAY:
		case ATOM:
			if(is_node_in_list(var_name, abs_var_list, i) == 1) {
				return 1;
			} else
				return 0;
		default:
			return 0;
	}
}


node_ptr find_var_def(node_ptr ref_var, node_ptr ref_var_list, node_ptr real_var_list) {
	node_ptr tempitem, tempitem2, item, item2;
	if(ref_var -> type != ATOM) return NIL;
	for (tempitem=ref_var_list,item=car(tempitem),tempitem2=real_var_list,item2=car(tempitem2); item&&item2; tempitem=cdr(tempitem),item=(tempitem==NIL)?NIL:car(tempitem),tempitem2=cdr(tempitem2),item2=(tempitem2==NIL)?NIL:car(tempitem2)) {
		if(string_eq(atom_to_string(ref_var),atom_to_string(item))){
			return item2;
		}
	}
	return NIL;	
}

// Recursively check whether the predicate exist abstract subformula. 1 implies Yes, 0 implies No.
int check_abs_pred_t1(node_ptr pred, int polar, node_ptr ref_var_list, node_ptr real_var_list) {
	if (pred == NIL) return (-1);
	//print_node(stdout,pred);
	//printf("\n");
	switch (pred->type) {
	case ATOM:
		if (is_abs_var(find_var_def(pred, ref_var_list, real_var_list),npa)) {
			return (1);
		} else {
			return (0);
		}
	case EQUAL:
	case NOTEQUAL:
		if (is_abs_var(find_var_def(car(pred), ref_var_list, real_var_list),npa) || is_abs_var(find_var_def(cdr(pred), ref_var_list, real_var_list),npa)) {
			return (1);
		} else {
			return (0);
		}
	case AND:
	case OR:
	case IFF:
		return (check_abs_pred_t1(car(pred), polar ,ref_var_list ,real_var_list) || check_abs_pred_t1(cdr(pred), polar ,ref_var_list ,real_var_list));
	case NOT:
		return (check_abs_pred_t1(car(pred), -(polar) ,ref_var_list ,real_var_list));
	case IMPLIES:
		return (check_abs_pred_t1(car(pred), -(polar) ,ref_var_list ,real_var_list) || check_abs_pred_t1(cdr(pred), polar ,ref_var_list ,real_var_list));
	default:
		return (0);
	}
}

/*
 * Recursively check the predicate pred. If the atom formula is abstract related formula
 * decided by absvars, and it occurs postive in predicate(polar = 1), then substitute TRUE for this atom formula. 
 * Otherwise(polar = -1), substitute FALSE for it.
 */
int modify_abs_pred_t1(node_ptr pred, int polar, node_ptr ref_var_list, node_ptr real_var_list) {
	int l, r;
	node_ptr tempptr;
	if (pred == NIL) return (1);	
	switch (pred->type) {
	case ATOM:
		if (is_abs_var(find_var_def(pred, ref_var_list, real_var_list),npa)) {
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if(polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case EQUAL:
	case NOTEQUAL:	
			//print_node(stdout, pred);
	//printf("\n%d\n",pred->type);
		if (is_abs_var(find_var_def(car(pred), ref_var_list, real_var_list),npa) || is_abs_var(find_var_def(cdr(pred), ref_var_list, real_var_list),npa)) {
			//print_node(stdout, pred);
	//printf("\n%d\n",pred->type);	
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if(polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case AND:
	case OR:
	case IFF:
		tempptr = cdr(pred);
		l = modify_abs_pred_t1(car(pred), polar ,ref_var_list ,real_var_list);
		r = modify_abs_pred_t1(tempptr, polar ,ref_var_list ,real_var_list);
		return (l || r);
	case NOT:
		return (modify_abs_pred_t1(car(pred), -(polar) ,ref_var_list ,real_var_list));
	case IMPLIES:
		return (modify_abs_pred_t1(car(pred), -(polar) ,ref_var_list ,real_var_list) || modify_abs_pred_t1(cdr(pred), polar ,ref_var_list ,real_var_list));
	default:
		return (0);
	}
}

int modify_inst_pred_t1(node_ptr pred, int polar) {
	int l, r;
	if (pred == NIL) return (1);
	switch (pred->type) {
	case DOT:
	case ARRAY:
	case ATOM:
		if (is_abs_var(pred,npa)) {
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if(polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case EQUAL:
	case NOTEQUAL:		
		if (is_abs_var(car(pred),npa) || is_abs_var(cdr(pred),npa)) {
			pred->left.nodetype = NIL;
			pred->right.nodetype = NIL;
			if(polar == 1)
				pred->type = TRUEEXP;
			else
				pred->type = FALSEEXP;
			return (1);
		} else {
			return (0);
		}
	case AND:
	case OR:
	case IFF:
		l = modify_inst_pred_t1(car(pred), polar);
		r = modify_inst_pred_t1(cdr(pred), polar);
		return (l || r);
	case NOT:
		return (modify_inst_pred_t1(car(pred), -(polar)));
	case IMPLIES:
		return (modify_inst_pred_t1(car(pred), -(polar)) || modify_inst_pred_t1(cdr(pred), polar));
	default:
		return (0);
	}
}

int check_abs_module_t1(node_ptr use_var, node_ptr old_module) {
	node_ptr decs, dec, tempdec, rules, rule, temprule, exprs, expr, tempexpr, items, items2, item2, pred, ph;
	node_ptr tempptr = NIL;
	int polar;
	items = cdar(old_module);
	items2 = cdr(car(cdr(use_var)));
	decs = cdr(old_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == ASSIGN) {
			rules = car(dec);
			if(rules == NIL)
				return 0;
			LOOP_OVER_RULES(rules, rule, temprule) {
				if(rule->type == EQDEF && car(rule)->type == NEXT) {
					item2 = find_var_def(caar(rule), items,items2);	
					if(is_abs_var(item2,npa) == 0) {
						exprs = cdr(rule);
						if(exprs->type == CASE){
							LOOP_OVER_RULES(exprs,expr,tempexpr) {
								if(expr->type == COLON) {
									pred = car(expr);
									polar = 1;								                       
									if(check_abs_pred_t1(pred,polar,items,items2)==1) {
										if(check_inst_pred(fts_list->components,car(use_var),pred) == 0) {
											ph = find_pred_assoc(abs_pred_hash, pred);
											if(ph == NIL || !string_eq(atom_to_string(find_assoc(ph_name_hash, ph)),atom_to_string(car(use_var)))) {
												ph = gene_ph(&ph_count);
												ph_list = cons(ph, ph_list);
												//pn(pred);
												//printf("\n");
												insert_assoc(abs_pred_hash, ph, pred);
												insert_assoc(ph_name_hash, ph, car(use_var));
											} 
										}
									}
								}
							}
						}
					}						
				}
			}		
		}
	}

	return 1;
}

node_ptr build_abs_module_t1(node_ptr use_var, node_ptr old_module, node_ptr abs_module) {
	node_ptr decs, dec, tempdec, rules, rule, temprule, exprs, expr, tempexpr, exprs2, expr2, tempexpr2, items, items2, item2, pred, pred2, ph;
	node_ptr tempptr = NIL;
	int polar;
	//pn(use_var);
	//printf("123\n");
	items = cdar(old_module);
	items2 = cdr(car(cdr(use_var)));
	decs = cdr(old_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == ASSIGN) {
			rules = car(dec);
			if(rules == NIL)
				return abs_module;
			LOOP_OVER_RULES(rules, rule, temprule) {
				if(rule->type == EQDEF && car(rule)->type == NEXT) {
					item2 = find_var_def(caar(rule), items,items2);	
					//printf("%s:%s->",atom_to_string(name_of_module(abs_module)),atom_to_string(caar(rule)));
					//print_node(stdout,item2);
					//printf("\n");
					if(is_abs_var(item2,npa)==1) {
						//printf("do not care this transition.\n");
					} else {
						tempptr = new_node(EQDEF,NIL,NIL);
						if(copy_node(rule, tempptr) == -1) {
							fprintf(stderr, "copy pred to abs_pred node error\n");
							return NIL;
						}
						cadr(abs_module)->left.nodetype = append(car(cadr(abs_module)),new_node(LIST,tempptr,NIL));
						//print_node(stdout,cdr(rule));
						exprs = cdr(rule);
						exprs2 = cdr(tempptr);
						if(exprs->type == CASE){
							//LOOP_OVER_RULES(exprs,expr,tempexpr) {
							for(tempexpr=exprs,expr=car(tempexpr),tempexpr2=exprs2,expr2=car(tempexpr2);expr&&expr2;tempexpr=cdr(tempexpr),expr=(tempexpr==NIL)?NIL:car(tempexpr),tempexpr2=cdr(tempexpr2),expr2=(tempexpr2==NIL)?NIL:car(tempexpr2)){
								if(expr->type == COLON) {
									pred = car(expr);
									pred2 = car(expr2);
									//print_node(stdout,expr);
									//printf("\n%d\n",pred->type);
									polar = 1;								                       
									if(check_abs_pred_t1(pred2,polar,items,items2)==1) {
										if(check_inst_pred(fts_list->components,car(use_var),pred) == 0) {
											//printf("true2\n");
											modify_abs_pred_t1(pred2,polar,items,items2);
											//ph = find_pred_assoc(abs_pred_hash, pred);
											ph = find_pred_name_assoc(abs_pred_hash, ph_name_hash, pred, car(use_var));
											if(ph == NIL) {
											//if(ph == NIL || !string_eq(atom_to_string(find_assoc(ph_name_hash, ph)),atom_to_string(car(use_var)))) {
												ph = gene_ph(&ph_count);
												ph_list = cons(ph, ph_list);
												//print_node(stdout,pred);
												//printf("\n");
												insert_assoc(abs_pred_hash, ph, pred);
												//pn(car(use_var));
												//printf("\n");
												insert_assoc(ph_name_hash, ph, car(use_var));
											} 
											//print_node(stdout,ph_list);
											pred2 = new_node(AND, ph, pred2);							 
											expr2->left.nodetype = pred2;
											//printf("\n");
											//printf("success\n");
										}
									}
								}
							}
						}
					}						
				}
			}		
		}
	}

	return abs_module;
}
node_ptr modify_remain_module(node_ptr use_var, node_ptr remain_module){
	node_ptr decs, dec, tempdec, rules, rule, temprule, exprs, expr, tempexpr, items, items2, item2, pred;
	int polar;
	items = cdar(remain_module);
	items2 = cdr(car(cdr(use_var)));
	decs = cdr(remain_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == ASSIGN) {
			rules = car(dec);
			if(rules == NIL)
				return NIL;
			LOOP_OVER_RULES(rules, rule, temprule) {
				if(car(rule)->type != NEXT)
					return NIL;
				item2 = find_var_def(caar(rule), items,items2);	
				//printf("%s:%s->",atom_to_string(name_of_module(remain_module)),atom_to_string(caar(rule)));
				//print_node(stdout,item2);
				//printf("\n");
				//printf("npa = %d\n",npa);
				if(is_abs_var(item2,npa)==1) {
					temprule->left.nodetype = NIL;
				} else {
					exprs = cdr(rule);
					if(exprs->type == CASE){
						LOOP_OVER_RULES(exprs,expr,tempexpr) {
							if(expr->type == COLON) {
								polar = 1;
								pred = car(expr);
								modify_abs_pred_t1(pred,polar,items,items2);
							}
						}
					}	
				}
			}
		}
	}
	return remain_module;
} 

int check_abs_tran(node_ptr tran_name, int id) {
	char* name_str;
	char* tmp;
	char tempstr[BUFLEN] = "";
	char tempstr2[BUFLEN] = "";
	//pn(tran_name);
	//printf("\n");
	sprintf(tempstr, "N%d", id);
	if(tran_name == NIL||tran_name->type!=ATOM) {
		return 0;
	}
	name_str = atom_to_string(tran_name);
	strcpy(tempstr2,name_str);
	//printf("tran name: %s\n",name_str);
	tmp = strtok(tempstr2, "_");
	if(tmp == NULL)
		return 0;
	//printf("tran name: %s\n",tmp);
	if(string_eq(tmp,tempstr)) {
		//printf("true\n");
		return 1;
	}
	tmp = strtok(strtok(NULL, "_"),"_");
	//printf("tran name: %s\n",tmp);
	if(tmp == NULL)
		return 0;
	if(string_eq(tmp,tempstr)) {
		//printf("true\n");
		return 1;
	}
	//printf("false\n");
	return 0;
}


int check_abs_program_t1 (node_ptr parse_tree, int proc_num, int flag) {
	char* tran_name;
	char tempstr[BUFLEN] = "";
	int len = 0;
	node_ptr modules, module, tempmodule, decs, dec, tempdec, vars, var, tempvar, main_module, new_name, old_module, abs_module, remain_module;
	node_ptr tempptr, type = NIL;

	if (!abs_pred_hash) {
		abs_pred_hash = new_assoc();
	}

	if (!ph_name_hash) {
		ph_name_hash = new_assoc();
	}

	main_module = find_module_by_name (parse_tree, "main");
	if(main_module == NIL) return 0;
	abs_var_list = gene_abs_var_list(parse_tree, main_module, proc_num);
  decs = cdr(main_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				if(cdr(var)->type == PROCESS) {
					if(car(var)->type == ATOM) {
						//check_abs_tran(car(var), npa);
						//tran_name = atom_to_string(car(var));					
						if(check_abs_tran(car(var), npa)==1){
							//pn(car(var));
							//printf("\n");	
							old_module = find_module_by_name(parse_tree,atom_to_string(caar(cdr(var))));
							check_abs_module_t1(var, old_module);
						} 
					}
				}			
			}
		}
	}

	return 0;
}

/*
int reset(){
	ph_count = 1;
	ph_list = NIL;
   abs_pred_hash = NIL;
   ph_name_hash = NIL;
}
*/

int build_abs_program_t1 (node_ptr parse_tree, int proc_num, int flag) {
	char* tran_name;
	char tempstr[BUFLEN] = "";
	int len = 0;
	node_ptr modules, module, tempmodule, decs, dec, tempdec, vars, var, tempvar, main_module, new_name, old_module, abs_module, remain_module;
	node_ptr tempptr, type = NIL;
	//reset();
	if (!abs_pred_hash) {
		abs_pred_hash = new_assoc();
	}
	if (!ph_name_hash) {
		ph_name_hash = new_assoc();
	}
	main_module = find_module_by_name (parse_tree, "main");
	if(main_module == NIL) return 0;
	abs_var_list = gene_abs_var_list(parse_tree, main_module, proc_num);
	//print_node(stdout,abs_var_list);
	//printf("\n");
	//local_var_list = gene_local_var_list(parse_tree);
	//print_node(stdout,local_var_list);
	//printf("\n");
   decs = cdr(main_module);
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				if(cdr(var)->type == PROCESS) {
					if(car(var)->type == ATOM) {
						//pn(car(var));												
						//if(string_eq(tran_name,"N1_Chan1")){
							//printf("get it\n");
						//}
						//check_abs_tran(car(var), npa);
						tran_name = atom_to_string(car(var));					
						//printf("tran name : %s\n",tran_name);
						//printf("finish\n");
						if (((atype == 1) && (check_abs_tran(car(var), npa)==1))
								|| ((atype == 2) && (tran_name[0] == 'N'))){			
							abs_module = new_node(MODULE, new_node(MODTYPE,gene_abs_name(car(var)),NIL), new_node(LIST,new_node(ASSIGN,NIL,NIL),NIL));
							//pn(abs_module);
							//printf("\n");		
							old_module = find_module_by_name(parse_tree,atom_to_string(caar(cdr(var))));
							tempptr = new_node(cdar(old_module)->type,NIL,NIL);
							if(copy_node(cdar(old_module), tempptr) == -1) {
								fprintf(stderr, "copy pred to abs_pred node error\n");
								return -1;
							}
							car(abs_module)->right.nodetype = tempptr;
							abs_module = build_abs_module_t1(var, old_module, abs_module);
							//printf("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n");
							//print_node(stdout,abs_module);
							//printf(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");
							parse_tree = append(parse_tree, new_node(AND,abs_module,NIL));
							//print_node(stdout,parse_tree);
							//printf("\n");
							//printf("%s\n",atom_to_string(new_name));
							cadr(var)->left.nodetype = gene_abs_name(car(var));
							//print_node(stdout,var);						
						} 
					}
				}			
			}
		}
	}
	gene_inst_pred_t1(fts_list->components, ph_list);
	gene_inst_aux_pred_t1(fts_list->components, ph_list);
	//print_node(stdout,ph_list);
	//printf("\n");
	if(atype == 1 && flag == 1) {
		modules = parse_tree;
		LOOP_OVER_MODULES(modules, module, tempmodule){		
			strcpy(tempstr,atom_to_string(name_of_module(module)));
			//pn(name_of_module(module));
			//printf("\n %s \n",tempstr);
			if(!string_eq(tempstr,"main")){
				memset(tempstr, '\0', BUFLEN);
				first_n_string(atom_to_string(name_of_module(module)),tempstr,4);				
				tempptr = NIL;
				//printf("---%s\n",tempstr);
				if(!string_eq(tempstr,"ABS_")){
					LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
						if (dec->type == VAR) {
							vars = car(dec);
							LOOP_OVER_VARS(vars, var, tempvar) {
								if(cdr(var)->type == PROCESS) {
									if(car(var)->type == ATOM) {
										if(string_eq(atom_to_string(caar(cdr(var))),atom_to_string(name_of_module(module)))) {
											tempptr = var;
											break;
										}
									}
								}
							}
						}
					}
				}
				if(tempptr != NIL) {
					//pn(tempptr);
					//printf("done\n");
					module = modify_remain_module(tempptr, module);
				}
			}
		}
	}
		
		LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
			//printf("modify\n");
			//print_node(stdout, dec);
			//printf("\n");
			if (dec->type == VAR) {
				vars = car(dec);
				LOOP_OVER_VARS(vars, var, tempvar) {
					//print_node(stdout, tempvar);
					//printf("\n");
					if(cdr(var)->type == PROCESS) {
						if(car(var)->type == ATOM) {
							//print_node(stdout, var);
							//printf("\n");
							tran_name = atom_to_string(car(var));
							//printf("%s\n", tran_name);
							//print_node(stdout,ph_list);
							//printf("\n");
							if((atype == 2) || (atype == 1 && check_abs_tran(car(var), npa)==1)) {
								if(cadr(var)->type == MODTYPE) {
									cadr(var)->right.nodetype = append(cadr(var)->right.nodetype, ph_list);
									//print_node(stdout,var);
									//printf("\n");
								}
								//pn(caar(cdr(var)));
								//printf("\n");
								abs_module = find_module_by_name(parse_tree,atom_to_string(caar(cdr(var))));
								type = car(abs_module);
								//print_node(stdout,ph_list);
								//printf("\n");
								//print_node(stdout,type);
								//printf("\n");
								if (type->type == MODTYPE) {
									type->right.nodetype = append(type->right.nodetype, ph_list);
								}
								//printf("tran name : %s\n",tran_name);
								//printf("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<\n");
								//print_node(stdout,abs_module);
								//printf(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>\n");						
							}
						//printf("tran name : %s\n",tran_name);
					}			
				}
			}
		}
	}
		
	//print_node(stdout,find_module_by_name(parse_tree,"ABS_SendGntE"));
	return 0;
}

int gene_name(node_ptr abs_name, int i, node_ptr *new_name){
	char aux_name_str[BUFLEN]="";
	char tmpbuf[BUFLEN]="";
	char tempstr[BUFLEN] = "";
	sprintf(tempstr, "N%d", npa);
	//print_node(stdout, abs_name);
	//printf("\n");
	if(abs_name == NIL)
		return 0;
	if(abs_name -> type == ATOM){
		first_n_string(atom_to_string(abs_name),tmpbuf,2);
		strcpy(aux_name_str,atom_to_string(abs_name));
		if(string_eq(tmpbuf,tempstr)){			
			if(aux_name_str[1]-1==aux_name_str[4])
				i--;
			aux_name_str[1] = i + '0';
		} else {
			if(aux_name_str[4]-1==aux_name_str[1])
				i--;
			aux_name_str[4] = i + '0';
		}
	}
	//pn(abs_name);
	//printf("\n");
	//printf("%d:%s\n",i,aux_name_str);
	*new_name = string_to_atom(aux_name_str);
	//print_node(stdout, new_name);
	//printf("11\n");
	return 1;
}

int gene_inst_pred_t1(component_ptr c, node_ptr ph_list) {
	node_ptr phs, ph, apred, ipred, pred_F, context, name;
	if(ph_list == NIL)
		return 0;
	if(!inst_pred_hash) {
		inst_pred_hash = new_assoc();
	}
	phs = ph_list;
	for(ph = car(ph_list); ph; phs = cdr(phs), ph = (phs == NIL) ? NIL : car(phs)) {
		apred = find_assoc(abs_pred_hash, ph);
		name = find_assoc(ph_name_hash, ph);
		//print_node(stdout, apred);
		//printf(" : ");
		//print_node(stdout, name);
		//printf("\n");
		if(apred == NIL || name == NIL)
			return -1; 
		if ((ipred = find_inst_pred(c, name, apred)) == NIL) {
			fprintf(stdout, "find_inst_pred error\n");
			return (-1) ;
		}
		if ((context = find_inst_context(c, name)) == NIL) {
			fprintf(stdout, "find_inst_context error\n");
			return (-1) ;
		}
		
		pred_F = eval_F(ipred, context);
		insert_assoc(inst_pred_hash, ph, pred_F);
		//print_node(stdout, find_assoc(inst_pred_hash, ph));
		//printf(" : ");
		//print_node(stdout, name);
		//printf("\n");
	}
	return 1;
}

int gene_inst_aux_pred_t1(component_ptr c, node_ptr ph_list) {
	node_ptr phs, ph, apred, ipred, pred_F, context, name = NIL;
	//node_ptr name = string_to_atom("");
	if(ph_list == NIL)
		return 0;
	if(!inst_aux_pred_hash) {
		inst_aux_pred_hash = new_assoc();
	}
	phs = ph_list;
	for(ph = car(phs); ph; phs = cdr(phs), ph = (phs == NIL) ? NIL : car(phs)) {
		apred = find_assoc(abs_pred_hash, ph);
		if (atype == 1) {
			gene_name(find_assoc(ph_name_hash, ph),npa-1,&name);
		} else if (atype == 2) {
			if(check_abs_tran(find_assoc(ph_name_hash, ph),npa)==1){
				gene_name(find_assoc(ph_name_hash, ph),npa-1,&name);
			} else {
				 name = find_assoc(ph_name_hash, ph);
			}
		}
		//print_node(stdout, apred);
		//printf(" : ");
		//print_node(stdout, name);
		//printf("\n");
		if(apred == NIL || name == NIL)
			return -1; 
		if ((ipred = find_inst_pred(c, name, apred)) == NIL) {
			fprintf(stdout, "find_inst_pred error\n");
			return (-1) ;
		}
		if ((context = find_inst_context(c, name)) == NIL) {
			fprintf(stdout, "find_inst_context error\n");
			return (-1) ;
		}
		//print_node(stdout,apred);
		//printf("\n");
		pred_F = eval_F(ipred, context);
		insert_assoc(inst_aux_pred_hash, ph, pred_F);
		//print_node(stdout,ipred);
		//printf("\n");
		//print_node(stdout, find_assoc(inst_aux_pred_hash, ph));
		//printf("\n");
	}
	return 1;
}

int gene_var_list(node_ptr parse_tree, node_ptr name, node_ptr type, node_ptr *var_list) {
	int i, j;
	node_ptr tempptr = NIL;
	node_ptr defmodule = NIL;
	node_ptr decs, dec, tempdec, vars, var, tempvar = NIL;
	switch(type -> type) {
		case ARRAY:
			if(caar(type)->type == NUMBER)
				i = caar(type)->left.inttype;
			else
				i = npa;
			if(cdar(type)->type == NUMBER)	
				j = cdar(type)->left.inttype;
			else
				j = npa;
			for( ;i<=j;i++){
				tempptr = new_node(name->type, NIL, NIL);
				copy_node(name,tempptr);
				tempptr = new_node(ARRAY,tempptr,new_node(NUMBER,(node_ptr)i,NIL));
				gene_var_list(parse_tree, tempptr, cdr(type), var_list);
			}
			break;
		case MODTYPE:
			defmodule = find_module_by_name(parse_tree,atom_to_string(car(type)));
			decs = cdr(defmodule);
			LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
				if (dec->type == VAR) {
					vars = car(dec);
					LOOP_OVER_VARS(vars, var, tempvar) {
						if(cdr(var)->type != PROCESS) {
							tempptr = new_node(name->type, NIL, NIL);
							copy_node(name,tempptr);
							tempptr = new_node(DOT,tempptr,car(var));
							//pn(tempptr);
							//printf("\n");
							gene_var_list(parse_tree, tempptr, cdr(var), var_list);
						}
					}
				}
			}
			break;
		case TWODOTS:
		case SCALAR:
		case BOOLEAN:
			tempptr = new_node(name->type, NIL, NIL);
			copy_node(name,tempptr);
			*var_list = cons(tempptr,*var_list);
			//pn(*var_list);
			//printf("\n");
			break;
		default:
			break;
	}
	return 1;
}

int gene_inst_var_list(node_ptr parse_tree, component_ptr c) {
	node_ptr context = NIL;
	node_ptr items, item, tempitem = NIL;
	node_ptr items2, item2, tempitem2 = NIL;
	node_ptr nodes, node ,tempnode = NIL;
	node_ptr tempptr, node_module;
	node_ptr templist = NIL;
	node_ptr mainmodule = NIL;
	node_ptr decs, dec, tempdec, vars, var, tempvar = NIL;
	global_inst_var_list = NIL;
	local_inst_var_list = NIL;
	//global
	mainmodule = find_module_by_name(parse_tree, "main");
	decs = cdr(mainmodule);
	context = NIL;
	LOOP_OVER_DECLARATIONS(decs, dec, tempdec) {
		if (dec->type == VAR) {
			vars = car(dec);
			LOOP_OVER_VARS(vars, var, tempvar) {
				if(cdr(var)->type != PROCESS) {
					if(cdr(var)->type == MODTYPE) { //Node module
						node_module = find_module_by_name(parse_tree, atom_to_string(car(cdr(var))));
						if(check_module_has_init(node_module)==1){
							continue;
						}
					}
					templist = NIL;
					gene_var_list(parse_tree,car(var),cdr(var),&templist);
					items2 = templist;
					LOOP_OVER_ITEMS(items2, item2, tempitem2) {
						global_inst_var_list = cons(eval_struct(item2, context),global_inst_var_list);
						//pn(eval_struct(item2, context));
						//printf("\n");
					}
				}
			}
		}
	}
	//local
	items = local_var_list;
	LOOP_OVER_ITEMS(items, item, tempitem) {
		//printf("++++++++++++++++++++++++++++++++++++++++\n");
		//pn(item);
		//printf("++++++++++++++++++++++++++++++++++++++++\n");
		nodes = node_name_list;
		templist = NIL;
		gene_var_list(parse_tree,car(item),cdr(item),&templist);
		//pn(templist);
		//printf("\n");
		LOOP_OVER_ITEMS(nodes, node, tempnode) {
			//pn(node) ;
			//printf("\n");
			if ((context = find_inst_context(c, node)) == NIL) {
				fprintf(stdout, "find_inst_context error\n");
				return -1;
			}
			items2 = templist;
			LOOP_OVER_ITEMS(items2, item2, tempitem2) {
				local_inst_var_list = cons(eval_struct(item2, context),local_inst_var_list);
				//pn(eval_struct(item2, context));
				//printf("\n");
			}
			//printf("%d\n",cdr(item)->type);
			
		}
	}
	/*
	printf("---------------------------------------------\n");
	printf("global inst vars:\n");
	pn(global_inst_var_list);
	printf("\n");
	printf("\nlocal inst vars:\n");
	pn(local_inst_var_list);
	printf("\n---------------------------------------------\n");
	*/
	return 1;
}

/*int inst_var_list_t1(node_ptr parse_tree, component_ptr c, node_ptr name, int id, node_ptr *ivar_list) {
	node_ptr context;
	node_ptr avar_list;
	node_ptr avar = NIL;
	node_ptr real_var, tempptr, vars, var, tempvar, vars2, var2, tempvar2, tempmodule;
	//print_node(stdout,name);
	//printf("\n");
	if ((context = find_inst_context(c, name)) == NIL) {
		fprintf(stdout, "find_inst_context error\n");
		return -1;
	}
	real_var = find_tran_by_name(parse_tree, atom_to_string(name));
	tempmodule = find_module_by_name(parse_tree, atom_to_string(car(cadr(real_var))));
	vars = cdr(cadr(real_var));
	vars2 = cdar(tempmodule);
	//LOOP_OVER_VARS(vars, var, tempvar) {
	for(tempvar=vars,var=car(tempvar),tempvar2=vars2,var2=car(tempvar2);var&&var2;tempvar=cdr(tempvar),var=(tempvar==NIL)?NIL:car(tempvar),tempvar2=cdr(tempvar2),var2=(tempvar2==NIL)?NIL:car(tempvar2)){
		if(is_abs_var(var,id)==1) {
			tempptr = eval_struct(var2, context);
			//print_node(stdout, tempptr);
			//printf("\n");
			*ivar_list = cons(tempptr, *ivar_list);
		}
	}
	return 1;
}*/

/*
int inst_var_list_t1(node_ptr parse_tree, int id, node_ptr *ivar_list) {
	node_ptr items, item, tempitem = NIL;

	items = fts_list->variables;
	LOOP_OVER_ITEMS(items, item, tempitem) {
		if(is_abs_var(item,id) == 1){
			*ivar_list = cons(item, *ivar_list);
		}
	}

	return (0);
}
*/

int inst_var_list_t1(node_ptr parse_tree, int id, node_ptr *ivar_list) {
	node_ptr items, item, tempitem = NIL;
	//global
	items = global_inst_var_list;
	if (items != NIL) {
		LOOP_OVER_ITEMS(items, item, tempitem) {
			if(id == npa && is_abs_var(item,id) == 1){
				//printf("-------------------id = %d------------\n",id);
				//pn(item);
				//printf("\n");
				*ivar_list = cons(item, *ivar_list);
			}
		}
	}
	//local
	items = local_inst_var_list;
	if (items != NIL) {
		LOOP_OVER_ITEMS(items, item, tempitem) {
			//if(is_local_abs_var(item,id) == 1){
			if(is_abs_var(item,id) == 1){
				//printf("-------------------id = %d------------\n",id);
				//pn(item);
				//printf("\n");
				*ivar_list = cons(item, *ivar_list);
			}
		}
	}
	return (0);
}

int gene_ph_inv_pf(FILE *stream, node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i,j;
	node_ptr name, pred, name_list = NIL;
	char nph[BUFLEN] = ""; //name of some place holder
	char spred[BUFLEN] = ""; 
	char iph[BUFLEN]; //ith of some place holder
	char forsome_set[BUFLEN] = "set_"; //forsome set prefix 
	char fsn[BUFLEN] = ""; //forsome set name

	sprintf(nph, "%s", atom_to_string(ph));

if ((atype <= 1) || (atype == 2 && check_abs_tran(find_assoc(ph_name_hash, ph),npa) == 1)) {
	for(i = 1; i < npa; i++) {
		name_list = NIL;
		for(j = 1; j <= npa; j++) {
			if(j != i) {
				inst_var_list_t1(parse_tree, j, &name_list);
			}	
		}
		memset(iph, 0, sizeof(iph));
		sprintf(iph, "i%d_%s", i, nph);

		memset(fsn, 0, sizeof(fsn));
		sprintf(fsn, "%s%d_%s", forsome_set, i, nph);

		pred = find_assoc(inst_pred_hash, ph);

		fprintf(stream, "Let %s := support", fsn);
		fprint_list(stream, name_list);
		fprintf(stream, ";\n");

		fprintf(stream, "Let %s := (%s & ", iph, rs);
		memset(spred, 0, sizeof(spred));
		sprint_node(spred, BUFLEN, pred);
		fprintf(stream, "%s", spred);
		//fprint_Node(stream, pred);
		fprintf(stream, ") forsome %s;\n", fsn);
	}

	fprintf(stream, "Let %s := ", nph);

	i = 1;
	memset(iph, 0, sizeof(iph));
	sprintf(iph, "i%d_%s", i, nph);
	fprintf(stream, " %s", iph); 

	for(i = 2; i < npa; i++) {
		memset(iph, 0, sizeof(iph));
		sprintf(iph, "i%d_%s", i, nph);
		fprintf(stream, " & %s", iph); 
	}
	fprintf(stream, ";\n");
	fprintf(stream, "form %s;\n", nph);
} else {
	name_list = NIL;
	inst_var_list_t1(parse_tree, npa, &name_list);

	memset(iph, 0, sizeof(iph));
	sprintf(iph, "i%d_%s", i, nph);

	memset(fsn, 0, sizeof(fsn));
	sprintf(fsn, "%s%d_%s", forsome_set, i, nph);

	pred = find_assoc(inst_pred_hash, ph);

	fprintf(stream, "Let %s := support", fsn);
	fprint_list(stream, name_list);
	fprintf(stream, ";\n");

	memset(spred, 0, sizeof(spred));
	sprint_node(spred, BUFLEN, pred);

	/*
	fprintf(stream, "Let %s := (%s & ", iph, rs);
	fprintf(stream, "%s", spred);
	fprintf(stream, ") forsome %s;\n", fsn);

	fprintf(stream, "Let %s := (", nph);
	fprint_Node(stream, spred);
	fprintf(stream, ") -> %s;\n", iph); 
	*/

	fprintf(stream, "Let %s := (%s & ", nph, rs);
	fprintf(stream, "%s", spred);
	fprintf(stream, ") forsome %s;\n", fsn);

	fprintf(stream, "form %s;\n", nph);
}
	
	return 0;
}

int gene_and_print_ph_inv_t1(FILE *stream, node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i,j;
	node_ptr name, pred, name_list = NIL;
	node_ptr tempptr;
	bdd_ptr sup, reach, res, result;
	result = save_bdd(ONE);
	//tempptr = find_assoc(ph_name_hash, ph);
	for(i = 1; i < npa; i++) {
		//name_list = NIL;
		sup = save_bdd(ONE);
		for(j = 1; j <= npa; j++) {
			if(j != i) {
				name_list = NIL;
				inst_var_list_t1(parse_tree, j, &name_list);
				sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
			}	
		}
		pred = find_assoc(inst_pred_hash, ph);
		reach = and_bdd(eval(RS, NIL), eval(pred, NIL));
		res = forsome(sup, reach);
		dump_bdd_formula(stdout, res, 1, atom_to_string(ph));
		fflush(stdout);
		result = and_bdd(res, result);
		dump_bdd_formula(stdout, result, 1, atom_to_string(ph));
		fflush(stdout);
	}
	dump_bdd_formula(stream, result, 1, atom_to_string(ph));
	//fflush(stream);
	//dump_bdd_formula(stdout, result, 1, atom_to_string(ph));
	//fflush(stdout);
	//insert_assoc(inv_hash, ph, (node_ptr)result);
	return 1;
}

int gene_ph_inv_t1(node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i,j;
	node_ptr name, pred, name_list = NIL;
	node_ptr tempptr;
	bdd_ptr sup, reach, res, result;
	result = save_bdd(ONE);
	//tempptr = find_assoc(ph_name_hash, ph);
	for(i = 1; i < npa; i++) {
		//name_list = NIL;
		sup = save_bdd(ONE);
		for(j = 1; j <= npa; j++) {
			if(j != i) {
				//printf("\ni=%d,j=%d\n",i,j);
				//gene_name(tempptr,j,&name);
				//print_node(stdout,name);
				name_list = NIL;
				inst_var_list_t1(parse_tree, j, &name_list);
				//pn(name_list);
				//printf("\n");
				sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
			}	
		}
		pred = find_assoc(inst_pred_hash, ph);
		reach = and_bdd(eval(RS, NIL), eval(pred, NIL));
		res = forsome(sup, reach);
		//dump_bdd_formula(stdout, res, 1, atom_to_string(ph));
		result = and_bdd(res, result);
		//dump_bdd_formula(stdout, result, 1, atom_to_string(ph));
	}
	insert_assoc(inv_hash, ph, (node_ptr)result);
	//print_node(stdout,(node_ptr)result);
	//printf("zhouyan\n");
	return 1;
}

int gene_ph_aux_inv_pf(FILE *stream, node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i = 1, j;
	node_ptr name, aux_pred, name_list = NIL;
	char nph[BUFLEN] = ""; //name of some place holder
	char spred[BUFLEN] = ""; 
	char iph[BUFLEN]; //ith of some place holder
	char forsome_set[BUFLEN] = "set_"; //forsome set prefix 
	char fsn[BUFLEN] = ""; //forsome set name

	sprintf(nph, "aux_%s", atom_to_string(ph));

	name_list = NIL;
	if ((atype <= 1) || (atype == 2 && check_abs_tran(find_assoc(ph_name_hash, ph),npa) == 1)) {
		for(j = 1; j <= npa; j++) {
			if(j != i) {
				inst_var_list_t1(parse_tree, j, &name_list);
			}	
		}
	} else {
		inst_var_list_t1(parse_tree, npa, &name_list);
	}

	memset(iph, 0, sizeof(iph));
	sprintf(iph, "i%d_%s", i, nph);

	memset(fsn, 0, sizeof(fsn));
	sprintf(fsn, "%s%d_%s", forsome_set, i, nph);

	aux_pred = find_assoc(inst_aux_pred_hash, ph);

	fprintf(stream, "Let %s := support", fsn);
	fprint_list(stream, name_list);
	fprintf(stream, ";\n");

	fprintf(stream, "Let %s := (%s & ", iph, rs);
	memset(spred, 0, sizeof(spred));
	sprint_node(spred, BUFLEN, aux_pred);
	fprintf(stream, "%s", spred);
	//fprint_Node(stream, aux_pred);
	fprintf(stream, ") forsome %s;\n", fsn);

	fprintf(stream, "Let %s := (", nph);
	fprint_Node(stream, aux_pred);
	fprintf(stream, ") -> %s;\n", iph); 

	fprintf(stream, "form %s;\n", nph);
	
	return 0;
}

int gene_and_print_ph_aux_inv_t1(FILE * stream, node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i = 1, j;
	node_ptr name, pred, aux_pred, name_list, real_var = NIL;
	node_ptr tempptr;
	bdd_ptr sup = ONE, reach, res, result;
	name_list = NIL;
	char auxs[BUFLEN]= "aux_"; 
	char buf[BUFLEN];
	sup = save_bdd(ONE);
	for(j = 1; j <= npa; j++) {
		if (j != i) {
			name_list = NIL;
			inst_var_list_t1(parse_tree, j,&name_list);
			sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
		}
	}

	aux_pred = find_assoc(inst_aux_pred_hash, ph);
	reach = and_bdd(eval(RS, NIL), eval(aux_pred, NIL));
	res = forsome(sup, reach);
	modify_inst_pred_t1(aux_pred,1);
	result = or_bdd(not_bdd(eval(aux_pred, NIL)), res);
	memset(buf, 0, sizeof(buf));
	strcpy(buf, auxs);
	strcat(buf, atom_to_string(ph));
	dump_bdd_formula(stream, result, 1, buf);
	//fflush(stream);
	//dump_bdd_formula(stdout, result, 1, buf);
	//fflush(stdout);
	//insert_assoc(aux_inv_hash, ph, (node_ptr)result);
	return (0);
} 

int gene_ph_aux_inv_t1(node_ptr parse_tree, component_ptr c, node_ptr ph) {
	int i = 1, j;
	node_ptr name, pred, aux_pred, name_list, real_var = NIL;
	node_ptr tempptr;
	bdd_ptr sup = ONE, reach, res, result;
	name_list = NIL;
	sup = save_bdd(ONE);
	//tempptr = find_assoc(ph_name_hash, ph);
	for(j = 1; j <= npa; j++) {
		if (j != i) {
			//gene_name(tempptr,j,&name);
			name_list = NIL;
			inst_var_list_t1(parse_tree, j,&name_list);
			//pn(name_list);
			//printf("\n");
			sup = and_bdd((bdd_ptr)calc_list_support(name_list), sup);
		}
	}

	aux_pred = find_assoc(inst_aux_pred_hash, ph);
	reach = and_bdd(eval(RS, NIL), eval(aux_pred, NIL));
	res = forsome(sup, reach);
	//print_node(stdout,aux_pred);
	//printf("\n");	
	modify_inst_pred_t1(aux_pred,1);
	//print_node(stdout,aux_pred);
	//printf("\n");
	result = or_bdd(not_bdd(eval(aux_pred, NIL)), res);
	insert_assoc(aux_inv_hash, ph, (node_ptr)result);
	return (0);
} 

int gene_inv_pf(FILE *stream, node_ptr parse_tree, component_ptr c, node_ptr ph_list) {
	node_ptr ph, phs;

	if(ph_list == NIL)
		return 0;

	fprintf(stream, "Let %s := reachable();\n", rs);
	phs = ph_list;
	for(ph = car(phs); ph; phs = cdr(phs), ph = (phs == NIL) ? NIL : car(phs)) {
		gene_ph_inv_pf(stream, parse_tree, c, ph);
		gene_ph_aux_inv_pf(stream, parse_tree, c, ph);
	}
	fprintf(stream, "quit;\n");
	//printf("done\n");
	return 0;
}

int gene_and_print_inv_t1(FILE *stream, node_ptr parse_tree, component_ptr c, node_ptr ph_list) {
	node_ptr ph, phs;
	if(ph_list == NIL)
		return 0;
	/*
	if (!inv_hash) {
		inv_hash = new_assoc();
	}
	if (!aux_inv_hash) {
		aux_inv_hash = new_assoc();
	}
	*/
	phs = ph_list;
	//gene_inst_var_list(parse_tree, c);
	for(ph = car(phs); ph; phs = cdr(phs), ph = (phs == NIL) ? NIL : car(phs)) {
		//printf("\ngenerate ph inv start.\n");
		gene_and_print_ph_inv_t1(stream, parse_tree, c, ph);
		//printf("\ngenerate ph inv finished.\n");
		gene_and_print_ph_aux_inv_t1(stream, parse_tree, c, ph);
	}
	//printf("done\n");
	return 1;
}

int gene_inv_t1(node_ptr parse_tree, component_ptr c, node_ptr ph_list) {
	node_ptr ph, phs;
	if(ph_list == NIL)
		return 0;
	if (!inv_hash) {
		inv_hash = new_assoc();
	}
	if (!aux_inv_hash) {
		aux_inv_hash = new_assoc();
	}
	phs = ph_list;
	//gene_inst_var_list(parse_tree, c);
	for(ph = car(phs); ph; phs = cdr(phs), ph = (phs == NIL) ? NIL : car(phs)) {
		//printf("\ngenerate ph inv start.\n");
		gene_ph_inv_t1(parse_tree, c, ph);
		//printf("\ngenerate ph inv finished.\n");
		gene_ph_aux_inv_t1(parse_tree, c, ph);
	}
	//printf("done\n");
	return 1;
}
