#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>
#define BUFLEN 2048
static char *myname;
int npa;
char* pam_file;
char* smv_file;

/* Replace all occurrences of a string in another */
int replace(char *newchar, int len, char *old, char *mch, char *rpl) {
    char *tmp;
    int count;
    int shift;
    int nlen;
    int olen;
    int mlen;
    int rlen;
    int x;
    /* The new buffer is NULL, fail */
    if (newchar==NULL) return(-1);
    /* The length of the buffer is less than zero, fail */
    if (len<0) return(-2);
    /* The old buffer is NULL, fail */
    if (old==NULL) return(-3);
    /* The string to be matched is NULL or empty, simply copy */
    if ((mch==NULL)||(strlen(mch)==0)) {
        olen=strlen(old);
        if (len<=olen) return(olen+1);
        strcpy(newchar,old);
        return(0);
    }
    /* The string to be replaced is NULL, assume it's an empty string */
    if (rpl==NULL) rpl="";
    /* Evaluate some lengths */
    olen=strlen(old);
    mlen=strlen(mch);
    rlen=strlen(rpl);
    /* Calculate how many times the mch string appears in old */
    tmp=old;
    count=0;
    while((tmp=strstr(tmp,mch))!=NULL) {
        count++;
        tmp+=mlen;
    }
    /* We have no matches, simply copy */
    if (count==0) {
        olen=strlen(old);
        if (len<=olen) return(olen+1);
        strcpy(newchar,old);
        return(0);
    }
    /* Calculate how big the buffer must be to hold the translation
       and of how many bytes we need to shift the data */
    shift=rlen-mlen;
    nlen=olen+(shift*count);
    /* printf("Count=%d Shift= %d OLen=%d NLen=%d\n",count,shift,olen,nlen); */
    /* Check if we have enough size in the buffer */
    if (nlen>=len) return(nlen+1);
    /* Copy over the old buffer in the new one (save memory) */
    strcpy(newchar,old);
    /* Start replacing */
    tmp=newchar;
    while((tmp=strstr(tmp,mch))!=NULL) {
        /* If shift is > 0 we need to move data from right to left */
        if (shift>0) {
            for (x=(strlen(tmp)+shift);x>shift;x--) {
                /*
                printf("src %c(%d) dst %c(%d)\n",
                        tmp[x-shift],tmp[x-shift],tmp[x],tmp[x]);
                 */
                tmp[x]=tmp[x-shift];
            }
        /* If shift is < 0 we need to move data from left to right */
        } else if (shift<0) {
            for (x=mlen;x<strlen(tmp)-shift;x++) {
                /*
                   printf("src %c(%d) dst %c(%d)\n",
                          tmp[x],tmp[x],tmp[x+shift],tmp[x+shift]);
                 */
                tmp[x+shift]=tmp[x];
            }
        }
        /* If shift is = 0 we don't have to shift data */
        strncpy(tmp,rpl,rlen);
        tmp+=rlen;
        /* printf("\"%s\"\n",tmp); */
    }
    return(0);
}

void ltrim(char *s)//forward
{
    int l=0,p=0,k=0;
    l = strlen(s);
    if( l == 0 ) return;
    p = 0;
    while( s[p] == ' ' || s[p] == '\t' )  p++;
    if( p == 0 ) return;
    while( s[k] != '\0') s[k++] = s[p++];
    return;
}

void rtrim(char *s)//backward
{
    int l=0,p=0;
    l = strlen(s);
    if( l == 0 ) return;
    p = l -1;
    while( s[p] == ' ' || s[p] == '\t' ) {
        s[p--] = '\0';
        if( p < 0 ) break;
    }
    return;
}

int mspec(char *rp, char *str, char *old, char *new){
	char rp1[BUFLEN] = "";
	char rp2[BUFLEN] = "";
	sprintf(rp1,"[%s]",old);
	sprintf(rp2,"[%s]",new);
	replace(rp,BUFLEN,str,rp1,rp2);
	return 0;
}

int addAG(char *str, int n){
	char *p;
	if(n == 1) {
		p = strchr(str,')');
		ltrim(++p);
		sprintf(str,"\tAG %s",p);
	} else if(n == 2){
		p = strchr(str,'>');
		ltrim(++p);
		sprintf(str,"\tAG (%s",p);
	} else {
		fprintf(stderr, "TO MANY PARAMETERS\n");
		exit(0);
	}		
	return 0;
}

main(int argc, char **argv){
	//printf("pam2smv useage:./pam2smv -p Proc_no -f file\n");
	//printf("argc = %d\n",argc);
	myname = *(argv++);
	if(argc != 5){
		fprintf(stderr, "PARAMETER ERROR!\n");
		return;
	}
	argc--;
	while(argc){
		if(strcmp(*argv,"-p")==0){ 
			argv++;
      	sscanf(*(argv++),"%d",&npa);
		} else if(strcmp(*argv,"-f")==0){
	      argv++;
	      pam_file = *(argv++);
			smv_file = (char*)malloc(strlen(pam_file));
			strcpy(smv_file, pam_file);
			strtok(smv_file,".");
			strcat(smv_file,".smv");
		}
		argc -= 2;
	}
	/*
	printf("-------------------------------------------------\n");
	printf("npa = %d, pam file:%s, smv file:%s\n",npa,pam_file,smv_file);
	printf("-------------------------------------------------\n");
	*/
	FILE *pam_fp = NULL;
	FILE *smv_fp = NULL;
	if((pam_fp = fopen(pam_file, "rt")) == NULL){
		fprintf(stderr, "FILE OPENED ERROR!\n");
		return 0;
	}
	if((smv_fp = fopen(smv_file, "wt")) == NULL){
		fprintf(stderr, "FILE OPENED ERROR!\n");
		return 0;	
	}
	char data[BUFLEN];
	char tmp[BUFLEN];
	sprintf(tmp, "--Source file: %s , by pam2smv--\n", pam_file);
	fputs(tmp,smv_fp);
	int flag = 0;//0:none block, 1:MODULE, 2:VAR, 3:ASSIGN, 4:SPEC
	while(NULL != fgets(data,BUFLEN,pam_fp)){
		//fputs(data,stdout);
		strcpy(tmp, data);
		ltrim(tmp);
		if(strcmp(tmp, "\n") == 0){
			fputs(data,smv_fp);
			continue;
		}
		
		strcpy(tmp, data);
		strtok(tmp, " ");
		strtok(tmp, "\n");
		//fputs(tmp,stdout);
		//printf("\n");
		if(strcmp(tmp, "MODULE") == 0){
			flag = 1;
			//fputs(data,stdout);
			fputs(data,smv_fp);
			int mlflag = 0;
			if(NULL != strchr(data,'(')) mlflag = 1;
			while(mlflag == 1 && NULL == strchr(data,')')){//mutiple line
					fgets(data,BUFLEN,pam_fp);
					fputs(data,smv_fp);
			}
			char define_str[BUFLEN] = "";
			sprintf(define_str,"DEFINE\n\tN := %d;\n",npa);
			//fputs(define_str,stdout);
			fputs(define_str,smv_fp);
		} else if(strcmp(tmp, "VAR") == 0){
			flag = 2;
			//fputs(data,stdout);
			fputs(data,smv_fp);
		} else if(strcmp(tmp, "ASSIGN") == 0){
			flag = 3;
			//fputs(data,stdout);
			fputs(data,smv_fp);
		} else if(strcmp(tmp, "SPEC") == 0){
			flag = 4;
			//fputs(data,stdout);
			fputs(data,smv_fp);
		} else {
			char mldata[BUFLEN] = "";
			strcpy(mldata, data);
			//printf("flag = %d\n",flag);
			if(flag == 2 || flag == 3){//VAR & ASSIGN
				//x : y
				long curloc = 0L;
				while(strchr(mldata,';') == NULL){//mutiple line
					curloc = ftell(pam_fp);
					fgets(data,BUFLEN,pam_fp);
					strcpy(tmp, data);					
					if((strstr(tmp,"MODULE") != NULL) || (strstr(tmp,"VAR") != NULL) || (strstr(tmp,"ASSIGN") != NULL) || ((strstr(tmp,"SPEC") != NULL))){
						//fputs(tmp,stdout);
						fseek(pam_fp,curloc,0);
						break;
					}
					strcat(mldata,data);
				}
				//if(bflag == 1) continue;
				strcpy(tmp, mldata);
				//fputs(mldata,stdout);
				int pflag = 0;
				if(strstr(tmp, "transition") != NULL){
					pflag = 1;
				}
				strtok(tmp, ":");
				//fputs(tmp,stdout);
				//array: x[Proc] : ...
				if(strstr(tmp,"[Proc]") != NULL){
					if(pflag == 1)
						replace(mldata, BUFLEN, mldata, "array ", "");//delete array
					else
						replace(mldata, BUFLEN, mldata, "array ", "\t");//delete array							
					char num_str[2] = {'0','\0'};
					int i;
					for(i = 1; i <= npa; i++){			
						strcpy(tmp, mldata);		
						num_str[0] = i + '0';
						char var_str[BUFLEN] = "";
						if(pflag == 1){
							strtok(tmp,"[");
							ltrim(tmp);
							sprintf(var_str,"\tN%d_%s ",i,tmp);
							strcpy(tmp, mldata);
							strcat(var_str, strchr(tmp, ':'));
							//strchr(strtok(NULL,"["), ':');
							replace(tmp, BUFLEN, var_str, "transition", "process");
							//fputs(tmp,stdout);						
							//strcpy(tmp,var_str);
						} 
						replace(var_str, BUFLEN, tmp, "Proc", num_str);
						//fputs(var_str,stdout);					
						fputs(var_str,smv_fp);
						
					}
				} else { //x : Proc, x: array Proc of Proc
					strcpy(tmp, mldata);
					char var_str[BUFLEN] = "";
					if(strstr(tmp,"Proc") != NULL){
						replace(var_str, BUFLEN, tmp, "Proc", "1 .. N");
					} else {
						strcpy(var_str, tmp);
					}
					//fputs(var_str,stdout);
					fputs(var_str,smv_fp);
				}
			} else if(flag == 4){//SPEC
				//fputs(data,stdout);
				strcpy(tmp, data);
				if(strstr(tmp, "FORALL") != NULL){
					char *p,*q;
					//count the number of parameter
					int n = 0;
					strtok(tmp,"(");
					p = strtok(NULL,"(");
					strtok(p,")");
					q = strtok(p,",");
					while( (q != NULL) && (strcmp(q,"") != 0)){
						++n;
						q = strtok(NULL, ",");
					}
					//printf("n=%d\n",n);
					//replace
					strcpy(tmp, data);
					strtok(tmp,"(");
					p = strtok(NULL,"(");
					strtok(p,")");
					char rp[BUFLEN] = "";		
					switch(n){
						case(1):
							ltrim(p);
							rtrim(p);				
							mspec(rp, data, p, "1");
							addAG(rp, n);
							fputs(rp,smv_fp);
							fputs("SPEC\n",smv_fp);
							mspec(rp, data, p, "2");
							addAG(rp, n);
							//fputs(rp, stdout);							
							fputs(rp,smv_fp);
							break;
						case(2):
							strtok(p,",");
							q = strtok(NULL,",");
							ltrim(p);
							rtrim(p);
							ltrim(q);
							rtrim(q);
							mspec(rp, data, p, "1");
							mspec(rp, rp, q, "2");
							addAG(rp, n);
							//fputs(rp,stdout);
							fputs(rp,smv_fp);
							fputs("SPEC\n",smv_fp);
							mspec(rp, data, q, "1");
							mspec(rp, rp, p, "2");
							addAG(rp, n);
							//fputs(rp,stdout);
							fputs(rp,smv_fp);
							break;
						default:
							break;		
					}
				} else {
					fputs(data,smv_fp);
				}		
			} else {
				//fputs(data,stdout);
				fputs(data,smv_fp);
			}
		}
	}
	fclose(pam_fp);	
	fclose(smv_fp);
}
